import { Diagnostic } from "@siteimprove/alfa-act";
import { Array } from "@siteimprove/alfa-array";
import type { Element, Node } from "@siteimprove/alfa-dom";
import type { Hash } from "@siteimprove/alfa-hash";
import type { Iterable } from "@siteimprove/alfa-iterable";
/**
 * @public
 */
export declare class WithBadElements extends Diagnostic implements Iterable<Element> {
    static of(message: string, errors?: Iterable<Element>): WithBadElements;
    private readonly _errors;
    private constructor();
    get errors(): ReadonlyArray<Element>;
    equals(value: WithBadElements): boolean;
    equals(value: unknown): value is this;
    hash(hash: Hash): void;
    [Symbol.iterator](): Iterator<Element>;
    toJSON(options?: Node.SerializationOptions): WithBadElements.JSON;
}
/**
 * @public
 */
export declare namespace WithBadElements {
    interface JSON extends Diagnostic.JSON {
        errors: Array<Element.JSON>;
    }
    function isWithBadElements(value: Diagnostic): value is WithBadElements;
    function isWithBadElements(value: unknown): value is WithBadElements;
}
//# sourceMappingURL=with-bad-elements.d.ts.map