import type { Device } from "@siteimprove/alfa-device";
import type { Element } from "@siteimprove/alfa-dom";
import type { Result } from "@siteimprove/alfa-result";
import { Context } from "@siteimprove/alfa-selector";
import { Set } from "@siteimprove/alfa-set";
import type { Color } from "./color.js";
import { ColorErrors } from "./color-error.js";
/**
 * @public
 */
export type Background = ReadonlyArray<Color.Resolved>;
/**
 * Get the background colors of an element by :
 * 1. gathering all layers, until a fully opaque one is found.
 * 2. merging them into one composite color
 *
 * @public
 */
export declare function getBackground(element: Element, device: Device, context?: Context, opacity?: number, ignoredInterposedDescendants?: Set<Element>): Result<Background, ColorErrors<"background" | "layer">>;
//# sourceMappingURL=get-background.d.ts.map