import { Diagnostic, Rule } from "@siteimprove/alfa-act";
import type { Role } from "@siteimprove/alfa-aria";
import { Array } from "@siteimprove/alfa-array";
import { Element, Node } from "@siteimprove/alfa-dom";
import type { Hash } from "@siteimprove/alfa-hash";
import { Err, Ok } from "@siteimprove/alfa-result";
import type { Page } from "@siteimprove/alfa-web";
import * as aria from "@siteimprove/alfa-aria";
declare const _default: Rule.Atomic<Page, Element<string>, {}, Element<string>>;
export default _default;
/**
 * @public
 */
export declare class RoleAndRequiredAttributes extends Diagnostic {
    static of(message: string): Diagnostic;
    static of(message: string, role: Role.Name, requiredAttributes: ReadonlyArray<aria.Attribute.Name>, missingAttributes: ReadonlyArray<aria.Attribute.Name>): RoleAndRequiredAttributes;
    private readonly _role;
    private readonly _requiredAttributes;
    private readonly _missingAttributes;
    private constructor();
    get role(): Role.Name;
    get requiredAttributes(): ReadonlyArray<aria.Attribute.Name>;
    get missingAttributes(): ReadonlyArray<aria.Attribute.Name>;
    equals(value: RoleAndRequiredAttributes): boolean;
    equals(value: unknown): value is this;
    hash(hash: Hash): void;
    toJSON(options?: Node.SerializationOptions): RoleAndRequiredAttributes.JSON;
}
/**
 * @public
 */
export declare namespace RoleAndRequiredAttributes {
    interface JSON extends Diagnostic.JSON {
        role: string;
        attributes: {
            required: Array<aria.Attribute.Name>;
            missing: Array<aria.Attribute.Name>;
        };
    }
    function isRoleAndRequiredAttributes(value: Diagnostic): value is RoleAndRequiredAttributes;
    function isRoleAndRequiredAttributes(value: unknown): value is RoleAndRequiredAttributes;
}
/**
 * @public
 */
export declare namespace Outcomes {
    const HasAllStates: (role: Role.Name, required: ReadonlyArray<aria.Attribute.Name>, missing: ReadonlyArray<aria.Attribute.Name>) => Ok<RoleAndRequiredAttributes>;
    const HasNotAllStates: (role: Role.Name, required: ReadonlyArray<aria.Attribute.Name>, missing: ReadonlyArray<aria.Attribute.Name>) => Err<RoleAndRequiredAttributes>;
    const RuleError: Err<RoleAndRequiredAttributes>;
}
//# sourceMappingURL=rule.d.ts.map