import { Diagnostic, Rule } from "@siteimprove/alfa-act";
import type { Declaration } from "@siteimprove/alfa-dom";
import { Element, Node } from "@siteimprove/alfa-dom";
import type { Option } from "@siteimprove/alfa-option";
import { Err, Ok } from "@siteimprove/alfa-result";
import type { Page } from "@siteimprove/alfa-web";
declare const _default: Rule.Atomic<Page, Element<string>, {}, Element<string>>;
export default _default;
/**
 * @public
 */
export declare namespace Outcomes {
    const IsSufficient: (declaration: Option<Declaration>) => Ok<WithDeclaration>;
    const IsInsufficient: (declaration: Option<Declaration>) => Err<WithDeclaration>;
}
/**
 * @public
 */
export declare class WithDeclaration extends Diagnostic {
    static of(message: string, declaration?: Option<Declaration>): WithDeclaration;
    private readonly _declaration;
    constructor(message: string, declaration: Option<Declaration>);
    get declaration(): Option<Declaration>;
    equals(value: WithDeclaration): boolean;
    equals(value: unknown): value is this;
    toJSON(options?: Node.SerializationOptions): WithDeclaration.JSON;
}
/**
 * @public
 */
export declare namespace WithDeclaration {
    interface JSON extends Diagnostic.JSON {
        declaration: Option.JSON<Declaration>;
    }
    function isWithDeclaration(value: Diagnostic): value is WithDeclaration;
    function isWithDeclaration(value: unknown): value is WithDeclaration;
}
//# sourceMappingURL=rule.d.ts.map