import { Tag } from "@siteimprove/alfa-act";
/**
 * @public
 */
export declare class Scope<S extends string = string> extends Tag<"scope"> {
    static of<S extends string>(scope: S): Scope<S>;
    private readonly _scope;
    private constructor();
    get type(): "scope";
    get scope(): S;
    equals(value: Scope): boolean;
    equals(value: unknown): value is this;
    toJSON(): Scope.JSON<S>;
}
/**
 * @public
 */
export declare namespace Scope {
    interface JSON<S extends string = string> extends Tag.JSON<"scope"> {
        scope: S;
    }
    /**
     * For rules that test failures at the page level. These rules only make sense
     * to include in an audit if an entire page is available.
     */
    const Page: Scope<"page">;
    /**
     * For rules that test failures at the component level. These rules only make
     * sense to include in an audit if at least an entire component is available.
     */
    const Component: Scope<"component">;
}
//# sourceMappingURL=scope.d.ts.map